@echo off

:start
SET loopnum=0

echo Initializing...
cd "C:\Users\jexus\Desktop\CLMR\" 
START start.bat
goto run

:run
timeout 15
SET /A loopnum=loopnum+1
echo Script has completed %loopnum% loops.
@echo off

for /F "tokens=*" %%f in ('dir /od /b "C:\Users\jexus\Desktop\CLMR\*.txt"') do set _lastFile=%%f
echo Parsing for errors...
	
findstr /I /C:"CUDA error" "C:\Users\jexus\Desktop\CLMR\%_lastFile%" 
if %ERRORLEVEL% == 0 (
	echo CUDA Errors found>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
	goto :errorzero
) ELSE (
	goto :nex1
)
:nex1
findstr /I /C:"failed GPU" "C:\Users\jexus\Desktop\CLMR\%_lastFile%" 
if %ERRORLEVEL% == 0 (
	echo Failed GPU string found>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
	goto :errorzero
) ELSE (
	goto :nex2
)
:nex2
findstr /I /C:"unspecified launch failure" "C:\Users\jexus\Desktop\CLMR\%_lastFile%" 
if %ERRORLEVEL% == 0 (
	echo Unspecified Launch Failure string found>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
	goto :errorzero
) ELSE (
	goto :run2ME
)


:noerrors
echo No issues detected. Resume mining...
goto run
 

:errorzero
echo Error(s) found. Check shutdown.txt to see what was logged.
echo Rebooting now...
timeout 3
echo  %DATE:~10,4%-%DATE:~4,2%-%DATE:~7,2%>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
echo  %time%>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
echo "loopnumber: " %loopnum%>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
shutdown /r /t 3


@echo off
timeout 15

:run2ME
for /F "tokens=*" %%f in ('dir /od /b "C:\Users\jexus\Desktop\CLMR\*.txt"') do set _lastFile=%%f
for /f %%i in ('find /v /c "" ^< C:\Users\jexus\Desktop\CLMR\%_lastFile%') do set /a lines=%%i
timeout 15

for /f %%I in ('find /v /c "" ^< C:\Users\jexus\Desktop\CLMR\%_lastFile%') do set /a lines1=%%I
if %lines% == %lines1% (
	echo Looks like miner may have crashed, checking again ...
	goto :nex5
) ELSE (
	echo All is well.
	goto :noerrors
)

:nex5
timeout 10
for /f %%I in ('find /v /c "" ^< C:\Users\jexus\Desktop\CLMR\%_lastFile%') do set /a lines2=%%I
if %lines1% == %lines2% (
	echo Miner has died of dysentery ...
	echo Loggin into shutdowns.txt - Check for details as to why the shutdown.
	echo Line count match %lines% , %lines1% , %lines2%>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
	echo  %DATE:~10,4%-%DATE:~4,2%-%DATE:~7,2%>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
	echo  %time%>> "C:\Users\jexus\Desktop\CLMR\shutdowns.txt"
	echo Shutting down now ...
	shutdown /r /t 3
	pause
) ELSE (
	echo Close but all is well.
	timeout 3
	goto :noerrors
)












